> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.itential.com/itential-cloud/api-reference/automation-studio/import-automations/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server. # Import a new workflow document POST https://example.itential.io/automation-studio/automations/import Content-Type: application/json Imports a new workflow document. Reference: https://docs.itential.com/itential-cloud/api-reference/automation-studio/import-automations ## Authentication - `Authorization` header (basic auth, required) — Basic authentication of the form `Basic `. ## Request ### Body (application/json) This endpoint expects an object. - `automations` (list of object, optional) — Array of workflow documents to import. If '_id' is provided, it will be replaced with an autogenerated '_id'. - `name` (string, required) - `type` (string, required, default: automation) - `tasks` (object, required) - `workflow_start` (object, required) - `name` (string, optional) - `summary` (string, optional) - `groups` (list of object, optional) - `name` (string, required) - `provenance` (string, required) - `x` (double, optional) — Stores the x coordinate used by canvasVersion: 1 workflows - `y` (double, optional) — Stores the y coordinate used by canvasVersion: 1 workflows - `nodeLocation` (object, optional) — Stores the coordinates used by canvasVersion: 3 workflows - `x` (double, optional) - `y` (double, optional) - `workflow_end` (object, required) - `name` (string, optional) - `summary` (string, optional) - `groups` (list of object, optional) - `name` (string, required) - `provenance` (string, required) - `x` (double, optional) — Stores the x coordinate used by canvasVersion: 1 workflows - `y` (double, optional) — Stores the y coordinate used by canvasVersion: 1 workflows - `nodeLocation` (object, optional) — Stores the coordinates used by canvasVersion: 3 workflows - `x` (double, optional) - `y` (double, optional) - `error_handler` (object, optional) — Deprecated gen2-specific feature - `name` ("childJob", required) - `summary` (string, required) - `description` (string, required) - `app` (string, required) - `variables` (object, required) - `incoming` (object, required) - `outgoing` (object, required) - `error` (string, optional) - `decorators` (list of object, optional) - `type` (enum, optional) - Allowed values: `encryption`, `query` - `pointer` (string, optional) - `displayPath` (string, optional) - `groups` (list of object, required) - `name` (string, required) - `provenance` (string, required) - `type` ("operation", required) - `deprecated` (boolean, optional) - `scheduled` (boolean, optional) - `retrySettings` (object, optional, nullable) — Retry settings for a task. - `state` (list of enum, required) — Finish states the task will retry on. The task will retry on any of the included states. - Allowed values: `success`, `error`, `failure` - `autoRetry` (boolean, required) — Whether the task is set to retry automatically or manually. - `limit` (integer, required) — Limit of retries on a task before it will take normal transitions and stop retrying. - `delay` (integer, required) — Delay between each retry in milliseconds. - `count` (integer, optional) — Current retry count used for workflow engine job processing - `transitions` (object, required) - `workflow_start` (object, optional) - `workflow_end` (object, optional) - `error_handler` (object, optional) - `groups` (list of object, required) - `name` (string, required) - `provenance` (string, required) - `_id` (string, optional) - `uuid` (string, optional) - `namespace` (object, optional, nullable) - `type` (any, required) - `_id` (object, required) — A MongoDB ObjectId - `name` (string, required) - `description` (string, optional, nullable) - `preAutomationTime` (integer, optional) — Time (milliseconds) automation would have taken someone to complete without using IAP. - `sla` (integer, optional) - `errorHandler` (object, optional, nullable) — Deprecated gen2-specific feature - `type` (string, optional) - `name` (string, optional) - `font_size` (integer, optional, default: 12) — Deprecated, unused, gen1-specific feature - `created` (string, optional) - `created_by` (object or string, optional) - object - `username` (string, required) - `provenance` (string, required) - `createdBy` (string, optional) — Project related regression bug. This field needs to be accepted - `createdVersion` (string, optional) - `last_updated` (string, optional) - `last_updated_by` (object or string, optional) - object - `username` (string, required) - `provenance` (string, required) - `lastUpdatedVersion` (string, optional) — This value represents the semantic version of the application that last modified it. For workflows with canvasVersion = 1, this field will refer to the version of Workflow Builder. For workflows with canvasVersion > 1, this field will refer to the version of Studio. - `tags` (list of object, optional) - `_id` (string, required) - `name` (string, required) - `description` (string, required) - `canvasVersion` (enum, optional) - Allowed values: `1`, `1.5`, `2`, `3` - `encodingVersion` (enum, optional) - Allowed values: `1` - `inputSchema` (object, optional) - `outputSchema` (object, optional) - `outputData` (map from string to object, optional) — Deprecated gen2-specific feature - `taskId` (string, optional) - `taskPointer` (string, optional) - `decorators` (list of object, optional) - `type` (enum, optional) - Allowed values: `encryption`, `query` - `pointer` (string, optional) - `displayPath` (string, optional) - `migrationVersion` (integer, optional) - `scenarios` (list of object, optional) - `name` (string, required) - `input` (object, required) - `description` (string, optional) - `taskMocks` (object, optional) - `last_updated` (string, optional) - `last_updated_by` (object or string or map from string to any, optional) ## Response ### 200 Results from each individual import operation. - `imported` (list of object, optional) - `message` (string, required) — Message containing either confirmation of the import operation or the reason for the failure of the import operation. - `original` (object, required) — Accepts all generation workflow documents - `name` (string, required) - `type` (string, required, default: automation) - `tasks` (object, required) - `workflow_start` (object, required) - `name` (string, optional) - `summary` (string, optional) - `groups` (list of object, optional) - `name` (string, required) - `provenance` (string, required) - `x` (double, optional) — Stores the x coordinate used by canvasVersion: 1 workflows - `y` (double, optional) — Stores the y coordinate used by canvasVersion: 1 workflows - `nodeLocation` (object, optional) — Stores the coordinates used by canvasVersion: 3 workflows - `x` (double, optional) - `y` (double, optional) - `workflow_end` (object, required) - `name` (string, optional) - `summary` (string, optional) - `groups` (list of object, optional) - `name` (string, required) - `provenance` (string, required) - `x` (double, optional) — Stores the x coordinate used by canvasVersion: 1 workflows - `y` (double, optional) — Stores the y coordinate used by canvasVersion: 1 workflows - `nodeLocation` (object, optional) — Stores the coordinates used by canvasVersion: 3 workflows - `x` (double, optional) - `y` (double, optional) - `error_handler` (object, optional) — Deprecated gen2-specific feature - `name` ("childJob", required) - `summary` (string, required) - `description` (string, required) - `app` (string, required) - `variables` (object, required) - `incoming` (object, required) - `outgoing` (object, required) - `error` (string, optional) - `decorators` (list of object, optional) - `type` (enum, optional) - `pointer` (string, optional) - `displayPath` (string, optional) - `groups` (list of object, required) - `name` (string, required) - `provenance` (string, required) - `type` ("operation", required) - `deprecated` (boolean, optional) - `scheduled` (boolean, optional) - `retrySettings` (object, optional, nullable) — Retry settings for a task. - `state` (list of enum, required) — Finish states the task will retry on. The task will retry on any of the included states. - Allowed values: `success`, `error`, `failure` - `autoRetry` (boolean, required) — Whether the task is set to retry automatically or manually. - `limit` (integer, required) — Limit of retries on a task before it will take normal transitions and stop retrying. - `delay` (integer, required) — Delay between each retry in milliseconds. - `count` (integer, optional) — Current retry count used for workflow engine job processing - `transitions` (object, required) - `workflow_start` (object, optional) - `workflow_end` (object, optional) - `error_handler` (object, optional) - `groups` (list of object, required) - `name` (string, required) - `provenance` (string, required) - `_id` (string, optional) - `uuid` (string, optional) - `namespace` (object, optional, nullable) - `type` (any, required) - `_id` (object, required) — A MongoDB ObjectId - `name` (string, required) - `description` (string, optional, nullable) - `preAutomationTime` (integer, optional) — Time (milliseconds) automation would have taken someone to complete without using IAP. - `sla` (integer, optional) - `errorHandler` (object, optional, nullable) — Deprecated gen2-specific feature - `type` (string, optional) - `name` (string, optional) - `font_size` (integer, optional, default: 12) — Deprecated, unused, gen1-specific feature - `created` (string, optional) - `created_by` (object or string, optional) - object - `username` (string, required) - `provenance` (string, required) - `createdBy` (string, optional) — Project related regression bug. This field needs to be accepted - `createdVersion` (string, optional) - `last_updated` (string, optional) - `last_updated_by` (object or string, optional) - object - `username` (string, required) - `provenance` (string, required) - `lastUpdatedVersion` (string, optional) — This value represents the semantic version of the application that last modified it. For workflows with canvasVersion = 1, this field will refer to the version of Workflow Builder. For workflows with canvasVersion > 1, this field will refer to the version of Studio. - `tags` (list of object, optional) - `_id` (string, required) - `name` (string, required) - `description` (string, required) - `canvasVersion` (enum, optional) - Allowed values: `1`, `1.5`, `2`, `3` - `encodingVersion` (enum, optional) - Allowed values: `1` - `inputSchema` (object, optional) - `outputSchema` (object, optional) - `outputData` (map from string to object, optional) — Deprecated gen2-specific feature - `taskId` (string, optional) - `taskPointer` (string, optional) - `decorators` (list of object, optional) - `type` (enum, optional) - Allowed values: `encryption`, `query` - `pointer` (string, optional) - `displayPath` (string, optional) - `migrationVersion` (integer, optional) - `scenarios` (list of object, optional) - `name` (string, required) - `input` (object, required) - `description` (string, optional) - `taskMocks` (object, optional) - `last_updated` (string, optional) - `last_updated_by` (object or string or map from string to any, optional) - `created` (object, required, nullable) — The imported workflow as it exists after being imported. - `name` (string, required) - `type` (string, required, default: automation) - `tasks` (object, required) - `workflow_start` (object, required) - `name` (string, optional) - `summary` (string, optional) - `groups` (list of string, optional) - `nodeLocation` (object, optional) — Stores the coordinates used by canvasVersion: 3 workflows - `x` (double, optional) - `y` (double, optional) - `workflow_end` (object, required) - `name` (string, optional) - `summary` (string, optional) - `groups` (list of string, optional) - `nodeLocation` (object, optional) — Stores the coordinates used by canvasVersion: 3 workflows - `x` (double, optional) - `y` (double, optional) - `error_handler` (object, optional) — Deprecated gen2-specific feature - `name` ("childJob", required) - `summary` (string, required) - `description` (string, required) - `app` (string, required) - `variables` (object, required) - `incoming` (object, required) - `outgoing` (object, required) - `error` (string, optional) - `decorators` (list of object, optional) - `type` (enum, optional) - `pointer` (string, optional) - `displayPath` (string, optional) — Human-readable dot/bracket notation query (for query decorators) - `groups` (list of string, required) - `type` ("operation", required) - `nodeLocation` (object, optional) — Stores the coordinates used by canvasVersion: 3 workflows - `x` (double, optional) - `y` (double, optional) - `deprecated` (boolean, optional) - `scheduled` (boolean, optional) - `retrySettings` (object, optional, nullable) — Retry settings for a task. - `state` (list of enum, required) — Finish states the task will retry on. The task will retry on any of the included states. - Allowed values: `success`, `error`, `failure` - `autoRetry` (boolean, required) — Whether the task is set to retry automatically or manually. - `limit` (integer, required) — Limit of retries on a task before it will take normal transitions and stop retrying. - `delay` (integer, required) — Delay between each retry in milliseconds. - `count` (integer, optional) — Current retry count used for workflow engine job processing - `transitions` (object, required) - `workflow_start` (object, required) - `workflow_end` (object, required) - `error_handler` (object, optional) - `groups` (list of string, required) - `canvasVersion` (double, required) - `_id` (string, optional) - `uuid` (string, optional) - `namespace` (object, optional) - `type` (any, required) - `_id` (object, required) — A MongoDB ObjectId - `name` (string, required) - `description` (string, optional, nullable) - `preAutomationTime` (integer, optional) — Time (milliseconds) automation would have taken someone to complete without using IAP. - `sla` (integer, optional) - `errorHandler` (object, optional, nullable) — Deprecated gen2-specific feature - `type` (string, optional) - `name` (string, optional) - `font_size` (integer, optional, default: 12) — Deprecated, unused, gen1-specific feature - `created` (string, optional) - `created_by` (object or string, optional) - object - `username` (string, required) - `provenance` (string, required) - `createdVersion` (string, optional) - `last_updated` (string, optional) - `last_updated_by` (object or string, optional) - object - `username` (string, required) - `provenance` (string, required) - `lastUpdatedVersion` (string, optional) — This value represents the semantic version of the application that last modified it. For workflows with canvasVersion = 1, this field will refer to the version of Workflow Builder. For workflows with canvasVersion > 1, this field will refer to the version of Studio. - `tags` (list of string, optional) - `encodingVersion` (enum, optional) - Allowed values: `1` - `inputSchema` (object, optional) - `outputSchema` (object, optional) - `outputData` (map from string to object, optional) — Deprecated gen2-specific feature - `taskId` (string, optional) - `taskPointer` (string, optional) - `decorators` (list of object, optional) - `type` (enum, optional) - Allowed values: `encryption`, `query` - `pointer` (string, optional) - `displayPath` (string, optional) — Human-readable dot/bracket notation query (for query decorators) - `migrationVersion` (integer, optional) - `scenarios` (list of object, optional) - `name` (string, required) - `input` (object, required) - `description` (string, optional) - `taskMocks` (object, optional) - `last_updated` (string, optional) - `last_updated_by` (object or string or map from string to any, optional) - `edit` (string, required, nullable) — URI to the edit page for the imported workflow. - `success` (boolean, optional) — Status flag denoting the success (true) or failure (false) of the workflow's import operation. ## Errors ### 500 Internal Server Error Error response from API - `any` ## Examples **Request** ```json {} ``` **Response** ```json { "imported": [ { "message": "string", "original": { "name": "Port Turn Up IOS", "type": "automation", "tasks": { "workflow_start": { "name": "string", "summary": "string", "groups": [ { "name": "Admin", "provenance": "Pronghorn" } ], "x": 0, "y": 100 }, "workflow_end": { "name": "string", "summary": "string", "groups": [ { "name": "Admin", "provenance": "Pronghorn" } ], "x": 0, "y": 100 }, "error_handler": { "name": "Query", "summary": "Query Data Using 'json-query' Format", "description": "Query Data Using 'json-query' Format", "app": "Tools", "variables": { "incoming": {}, "outgoing": {}, "error": "string", "decorators": [ { "type": "encryption", "pointer": "string", "displayPath": "string" } ] }, "groups": [ { "name": "Admin", "provenance": "Pronghorn" } ], "type": "string", "deprecated": true, "scheduled": true, "retrySettings": { "state": [ "success" ], "autoRetry": true, "limit": 10, "delay": 1000, "count": 5 } } }, "transitions": { "workflow_start": {}, "workflow_end": {}, "error_handler": {} }, "groups": [ { "name": "Admin", "provenance": "Pronghorn" } ], "_id": "string", "uuid": "string", "namespace": null, "description": "Port Turn Up IOS", "preAutomationTime": 5000, "sla": 10, "errorHandler": null, "font_size": 12, "created": "2024-03-13T18:21:15.352Z", "created_by": { "provenance": "Pronghorn", "username": "admin@pronghorn" }, "createdBy": "string", "createdVersion": "5.40.5-2021.1.72.0", "last_updated": "2024-03-13T18:21:15.352Z", "last_updated_by": { "provenance": "Pronghorn", "username": "admin@pronghorn" }, "lastUpdatedVersion": "4.69.69", "tags": [ { "_id": "string", "name": "string", "description": "string" } ], "canvasVersion": 1, "encodingVersion": 1, "inputSchema": {}, "outputSchema": {}, "outputData": {}, "decorators": [ { "type": "encryption", "pointer": "string", "displayPath": "string" } ], "migrationVersion": 1, "scenarios": [ { "name": "string", "input": {}, "description": "string", "taskMocks": {}, "last_updated": "2024-01-15T09:30:00Z", "last_updated_by": { "provenance": "Pronghorn", "username": "admin@pronghorn" } } ] }, "created": { "name": "Port Turn Up IOS", "type": "automation", "tasks": { "workflow_start": { "name": "string", "summary": "string", "groups": [ "62a1f3d2ebedfc54e6e0065c" ], "nodeLocation": { "x": 1.1, "y": 1.1 } }, "workflow_end": { "name": "string", "summary": "string", "groups": [ "62a1f3d2ebedfc54e6e0065c" ], "nodeLocation": { "x": 1.1, "y": 1.1 } }, "error_handler": { "name": "string", "summary": "string", "description": "string", "app": "string", "variables": { "incoming": {}, "outgoing": {}, "error": "string", "decorators": [ { "type": "encryption", "pointer": "string", "displayPath": "string" } ] }, "groups": [ "62a1f3d2ebedfc54e6e0065c" ], "type": "string", "nodeLocation": { "x": 1.1, "y": 1.1 }, "deprecated": true, "scheduled": true, "retrySettings": { "state": [ "success" ], "autoRetry": true, "limit": 10, "delay": 1000, "count": 5 } } }, "transitions": { "workflow_start": {}, "workflow_end": {}, "error_handler": {} }, "groups": [ "62a1f3d2ebedfc54e6e0065c" ], "canvasVersion": 1.1, "_id": "string", "uuid": "string", "namespace": { "type": null, "_id": {}, "name": "Juniper JUNOS" }, "description": "Port Turn Up IOS", "preAutomationTime": 5000, "sla": 1, "errorHandler": null, "font_size": 12, "created": "2024-03-13T18:21:15.352Z", "created_by": { "provenance": "Pronghorn", "username": "admin@pronghorn" }, "createdVersion": "5.40.5-2021.1.72.0", "last_updated": "2024-03-13T18:21:15.352Z", "last_updated_by": { "provenance": "Pronghorn", "username": "admin@pronghorn" }, "lastUpdatedVersion": "4.69.69", "tags": [ "string" ], "encodingVersion": 1, "inputSchema": {}, "outputSchema": {}, "outputData": {}, "decorators": [ { "type": "encryption", "pointer": "string", "displayPath": "string" } ], "migrationVersion": 1, "scenarios": [ { "name": "string", "input": {}, "description": "string", "taskMocks": {}, "last_updated": "2024-01-15T09:30:00Z", "last_updated_by": { "provenance": "Pronghorn", "username": "admin@pronghorn" } } ] }, "edit": "string", "success": true } ] } ``` **SDK Code** ```python import requests url = "https://example.itential.io/automation-studio/automations/import" payload = {} headers = {"Content-Type": "application/json"} response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://example.itential.io/automation-studio/automations/import'; const options = {method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{}'}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://example.itential.io/automation-studio/automations/import" payload := strings.NewReader("{}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://example.itential.io/automation-studio/automations/import") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Content-Type"] = 'application/json' request.body = "{}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://example.itential.io/automation-studio/automations/import") .header("Content-Type", "application/json") .body("{}") .asString(); ``` ```php request('POST', 'https://example.itential.io/automation-studio/automations/import', [ 'body' => '{}', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://example.itential.io/automation-studio/automations/import"); var request = new RestRequest(Method.POST); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = [] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/automation-studio/automations/import")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```